SystemOrganization addCategory: #'Zinc-SSO-Seaside-Support'!

WARequestHandler subclass: #ZnOAuth2CallbackHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zinc-SSO-Seaside-Support'!

!ZnOAuth2CallbackHandler commentStamp: '<historical>' prior: 0!
A ZnOAuth2CallbackHandler is a simple request handler that handles the callbacks/redirects from OAuth2 providers.
!

!ZnOAuth2CallbackHandler methodsFor: 'handling' stamp: 'JanVanDeSandt 12/7/2012 16:58'!
handleFiltered: aRequestContext
	"Handle the oauth2 callback by redirecting to the correct application. The path to
	this application should be in a request parameter called 'state'."

	| state newUrl |

	state := aRequestContext request at: 'state'.
	state notNil
		ifTrue: [ 
			newUrl := WAUrl absolute: state.
			aRequestContext request queryFields keysAndValuesDo: [ :name :value |
				name ~= 'state'
					ifTrue: [ newUrl addField: name value: value ] ].
			aRequestContext responseGenerator
				redirectTo: newUrl; 
				respond ]
		ifFalse: [
			aRequestContext responseGenerator
				notFound;
				respond ]! !

WASystemConfiguration subclass: #ZnOAuth1TwitterConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zinc-SSO-Seaside-Support'!

!ZnOAuth1TwitterConfiguration commentStamp: '<historical>' prior: 0!
This Seaside configuration class defines the attributes required to use Twitter OAuth1!

!ZnOAuth1TwitterConfiguration methodsFor: 'description' stamp: 'JanVanDeSandt 12/23/2012 16:43'!
describeOn: config 

	(config string: #oauth1TwitterConsumerKey)
		group: #oauth;
		label: 'Twitter Consumer Key';
		comment: 'OAuth 1.0 consumer key'.
		
	(config string: #oauth1TwitterConsumerSecret)
		group: #oauth;
		label: 'Twitter Consumer Secret';
		comment: 'OAuth 1.0 consumer secret.'.	! !

WASystemConfiguration subclass: #ZnOAuth2FacebookConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zinc-SSO-Seaside-Support'!

!ZnOAuth2FacebookConfiguration commentStamp: '<historical>' prior: 0!
This Seaside configuration class defines the attributes required to use Facebook OAuth2!

!ZnOAuth2FacebookConfiguration methodsFor: 'description' stamp: 'JanVanDeSandt 12/7/2012 13:04'!
describeOn: config 

	(config string: #oauthFacebookClientId)
		group: #oauth;
		label: 'Facebook client_id';
		comment: 'OAuth 2.0 client_id for Facebook.'.
		
	(config string: #oauthFacebookClientSecret)
		group: #oauth;
		label: 'Facebook client_secret';
		comment: 'OAuth 2.0 client_secret for Facebook.'! !

WASystemConfiguration subclass: #ZnOAuth2GoogleConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zinc-SSO-Seaside-Support'!

!ZnOAuth2GoogleConfiguration commentStamp: '<historical>' prior: 0!
This Seaside configuration class defines the attributes required to use Google OAuth2!

!ZnOAuth2GoogleConfiguration methodsFor: 'description' stamp: 'JanVanDeSandt 12/7/2012 13:01'!
describeOn: config 

	(config string: #oauth2GoogleClientId)
		group: #oauth;
		label: 'Google oauth2 client_id';
		comment: 'OAuth 2.0 client_id for Google.'.
		
	(config string: #oauth2GoogleClientSecret)
		group: #oauth;
		label: 'Google oauth2 client_secret';
		comment: 'OAuth 2.0 client_secret for Google.'.	
		
	(config string: #oauth2GoogleRedirectUrl)
		group: #oauth;
		label: 'Google oauth2 redirect_url';
		comment: 'OAuth 2.0 redirect_url for Google.'.	! !

WASystemConfiguration subclass: #ZnOAuth2MicrosoftConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zinc-SSO-Seaside-Support'!

!ZnOAuth2MicrosoftConfiguration commentStamp: '<historical>' prior: 0!
This Seaside configuration class defines the attributes required to use Microsoft OAuth2!

!ZnOAuth2MicrosoftConfiguration methodsFor: 'description' stamp: 'JanVanDeSandt 12/8/2012 18:55'!
describeOn: config 

	(config string: #oauth2MicrosoftClientId)
		group: #oauth;
		label: 'Microsoft client_id';
		comment: 'OAuth 2.0 client_id for Microsoft Live Connect.'.
		
	(config string: #oauth2MicrosoftClientSecret)
		group: #oauth;
		label: 'Microsoft client_secret';
		comment: 'OAuth 2.0 client_secret for Microsoft Live Connect.'! !
